curl --request POST \
--url https://api-gateway.perflo.ai/v1/webhook-subscriptions/{id}/secret-rotations \
--header 'Authorization: Bearer <token>' \
--header 'DPoP: <api-key>' \
--header 'Idempotency-Key: <idempotency-key>'import requests
url = "https://api-gateway.perflo.ai/v1/webhook-subscriptions/{id}/secret-rotations"
headers = {
"Idempotency-Key": "<idempotency-key>",
"DPoP": "<api-key>",
"Authorization": "Bearer <token>"
}
response = requests.post(url, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'Idempotency-Key': '<idempotency-key>',
DPoP: '<api-key>',
Authorization: 'Bearer <token>'
}
};
fetch('https://api-gateway.perflo.ai/v1/webhook-subscriptions/{id}/secret-rotations', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api-gateway.perflo.ai/v1/webhook-subscriptions/{id}/secret-rotations",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"DPoP: <api-key>",
"Idempotency-Key: <idempotency-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"net/http"
"io"
)
func main() {
url := "https://api-gateway.perflo.ai/v1/webhook-subscriptions/{id}/secret-rotations"
req, _ := http.NewRequest("POST", url, nil)
req.Header.Add("Idempotency-Key", "<idempotency-key>")
req.Header.Add("DPoP", "<api-key>")
req.Header.Add("Authorization", "Bearer <token>")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api-gateway.perflo.ai/v1/webhook-subscriptions/{id}/secret-rotations")
.header("Idempotency-Key", "<idempotency-key>")
.header("DPoP", "<api-key>")
.header("Authorization", "Bearer <token>")
.asString();require 'uri'
require 'net/http'
url = URI("https://api-gateway.perflo.ai/v1/webhook-subscriptions/{id}/secret-rotations")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Idempotency-Key"] = '<idempotency-key>'
request["DPoP"] = '<api-key>'
request["Authorization"] = 'Bearer <token>'
response = http.request(request)
puts response.read_body{
"kid": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"secret": "<string>"
}{
"type": "<string>",
"title": "<string>",
"status": 499,
"detail": "<string>",
"instance": "<string>",
"code": "<string>",
"fields": [
{
"message": "<string>",
"path": "<string>"
}
],
"request_id": "<string>",
"retryable": true,
"submission_uncertain": true
}{
"type": "<string>",
"title": "<string>",
"status": 499,
"detail": "<string>",
"instance": "<string>",
"code": "<string>",
"fields": [
{
"message": "<string>",
"path": "<string>"
}
],
"request_id": "<string>",
"retryable": true,
"submission_uncertain": true
}{
"type": "<string>",
"title": "<string>",
"status": 499,
"detail": "<string>",
"instance": "<string>",
"code": "<string>",
"fields": [
{
"message": "<string>",
"path": "<string>"
}
],
"request_id": "<string>",
"retryable": true,
"submission_uncertain": true
}{
"type": "<string>",
"title": "<string>",
"status": 499,
"detail": "<string>",
"instance": "<string>",
"code": "<string>",
"fields": [
{
"message": "<string>",
"path": "<string>"
}
],
"request_id": "<string>",
"retryable": true,
"submission_uncertain": true
}{
"type": "<string>",
"title": "<string>",
"status": 499,
"detail": "<string>",
"instance": "<string>",
"code": "<string>",
"fields": [
{
"message": "<string>",
"path": "<string>"
}
],
"request_id": "<string>",
"retryable": true,
"submission_uncertain": true
}{
"type": "<string>",
"title": "<string>",
"status": 499,
"detail": "<string>",
"instance": "<string>",
"code": "<string>",
"fields": [
{
"message": "<string>",
"path": "<string>"
}
],
"request_id": "<string>",
"retryable": true,
"submission_uncertain": true
}{
"type": "<string>",
"title": "<string>",
"status": 499,
"detail": "<string>",
"instance": "<string>",
"code": "<string>",
"fields": [
{
"message": "<string>",
"path": "<string>"
}
],
"request_id": "<string>",
"retryable": true,
"submission_uncertain": true
}{
"type": "<string>",
"title": "<string>",
"status": 499,
"detail": "<string>",
"instance": "<string>",
"code": "<string>",
"fields": [
{
"message": "<string>",
"path": "<string>"
}
],
"request_id": "<string>",
"retryable": true,
"submission_uncertain": true
}Rotate a webhook signing secret
Activates a fresh signing-secret version for later deliveries while preserving retry authority for pinned older versions.
curl --request POST \
--url https://api-gateway.perflo.ai/v1/webhook-subscriptions/{id}/secret-rotations \
--header 'Authorization: Bearer <token>' \
--header 'DPoP: <api-key>' \
--header 'Idempotency-Key: <idempotency-key>'import requests
url = "https://api-gateway.perflo.ai/v1/webhook-subscriptions/{id}/secret-rotations"
headers = {
"Idempotency-Key": "<idempotency-key>",
"DPoP": "<api-key>",
"Authorization": "Bearer <token>"
}
response = requests.post(url, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'Idempotency-Key': '<idempotency-key>',
DPoP: '<api-key>',
Authorization: 'Bearer <token>'
}
};
fetch('https://api-gateway.perflo.ai/v1/webhook-subscriptions/{id}/secret-rotations', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api-gateway.perflo.ai/v1/webhook-subscriptions/{id}/secret-rotations",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"DPoP: <api-key>",
"Idempotency-Key: <idempotency-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"net/http"
"io"
)
func main() {
url := "https://api-gateway.perflo.ai/v1/webhook-subscriptions/{id}/secret-rotations"
req, _ := http.NewRequest("POST", url, nil)
req.Header.Add("Idempotency-Key", "<idempotency-key>")
req.Header.Add("DPoP", "<api-key>")
req.Header.Add("Authorization", "Bearer <token>")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api-gateway.perflo.ai/v1/webhook-subscriptions/{id}/secret-rotations")
.header("Idempotency-Key", "<idempotency-key>")
.header("DPoP", "<api-key>")
.header("Authorization", "Bearer <token>")
.asString();require 'uri'
require 'net/http'
url = URI("https://api-gateway.perflo.ai/v1/webhook-subscriptions/{id}/secret-rotations")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Idempotency-Key"] = '<idempotency-key>'
request["DPoP"] = '<api-key>'
request["Authorization"] = 'Bearer <token>'
response = http.request(request)
puts response.read_body{
"kid": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"secret": "<string>"
}{
"type": "<string>",
"title": "<string>",
"status": 499,
"detail": "<string>",
"instance": "<string>",
"code": "<string>",
"fields": [
{
"message": "<string>",
"path": "<string>"
}
],
"request_id": "<string>",
"retryable": true,
"submission_uncertain": true
}{
"type": "<string>",
"title": "<string>",
"status": 499,
"detail": "<string>",
"instance": "<string>",
"code": "<string>",
"fields": [
{
"message": "<string>",
"path": "<string>"
}
],
"request_id": "<string>",
"retryable": true,
"submission_uncertain": true
}{
"type": "<string>",
"title": "<string>",
"status": 499,
"detail": "<string>",
"instance": "<string>",
"code": "<string>",
"fields": [
{
"message": "<string>",
"path": "<string>"
}
],
"request_id": "<string>",
"retryable": true,
"submission_uncertain": true
}{
"type": "<string>",
"title": "<string>",
"status": 499,
"detail": "<string>",
"instance": "<string>",
"code": "<string>",
"fields": [
{
"message": "<string>",
"path": "<string>"
}
],
"request_id": "<string>",
"retryable": true,
"submission_uncertain": true
}{
"type": "<string>",
"title": "<string>",
"status": 499,
"detail": "<string>",
"instance": "<string>",
"code": "<string>",
"fields": [
{
"message": "<string>",
"path": "<string>"
}
],
"request_id": "<string>",
"retryable": true,
"submission_uncertain": true
}{
"type": "<string>",
"title": "<string>",
"status": 499,
"detail": "<string>",
"instance": "<string>",
"code": "<string>",
"fields": [
{
"message": "<string>",
"path": "<string>"
}
],
"request_id": "<string>",
"retryable": true,
"submission_uncertain": true
}{
"type": "<string>",
"title": "<string>",
"status": 499,
"detail": "<string>",
"instance": "<string>",
"code": "<string>",
"fields": [
{
"message": "<string>",
"path": "<string>"
}
],
"request_id": "<string>",
"retryable": true,
"submission_uncertain": true
}{
"type": "<string>",
"title": "<string>",
"status": 499,
"detail": "<string>",
"instance": "<string>",
"code": "<string>",
"fields": [
{
"message": "<string>",
"path": "<string>"
}
],
"request_id": "<string>",
"retryable": true,
"submission_uncertain": true
}Authorizations
Per-request RFC 9449 DPoP proof signed with ES256. Protected requests use Authorization: DPoP your_access_token_here. Create a new proof for the exact method and normalized target URI, and include the server nonce when challenged.
OAuth 2.0 with RFC 9700 security practices. Discover exact environment endpoints from /.well-known/openid-configuration and /.well-known/oauth-authorization-server, and discover the resource from /.well-known/oauth-protected-resource. Authorization-code clients use PKCE S256, the exact environment resource, nonce with openid, and DPoP binding. Confidential clients also require PAR and private_key_jwt. Access and refresh tokens are sender-constrained with DPoP. purchases:execute is unavailable and omitted from this scope registry.
Scopes
Read operations owned by the same subject and client.
Headers
Optional caller request identifier. Unsafe values are replaced with a generated UUID.
^[A-Za-z0-9._~-]{8,128}$A new 256-bit random value encoded as 43 unpadded base64url characters. Reuse it only for the same request intent.
^[A-Za-z0-9_-]{43}$Path Parameters
API-owned webhook-subscription identifier.
^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$Response
The new signing secret, including exact equal replay.
A newly rotated signing secret, or the same exact idempotency replay.
Identifier of the new signing-secret version.
^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$Base64url-encoded 256-bit signing secret disclosed initially and on exact idempotency replay.
^[A-Za-z0-9_-]{43}$